
local elapsed, updateperiod, brokertext, output = 0,1, "DailyBeanCounter"
DailyBeanCounter = {state = 4, dbversion = 1}

local function ConvertSeconds(value)
    local hours = floor(value / 3600)
    local minutes = value - (hours * 3600)
    minutes = floor(minutes / 60)
    local seconds = floor(value - ((hours * 3600) + (minutes * 60)))
    if hours > 0 then return hours,minutes,seconds
    elseif minutes > 0 then return 0,minutes,seconds
    else return 0,0,seconds
    end
end

local function stateChange()
	if DailyBeanCounter.state == 1 then
		DailyBeanCounter.state = 2
	elseif DailyBeanCounter.state == 2 then
		DailyBeanCounter.state = 3
	elseif DailyBeanCounter.state == 3 then
		DailyBeanCounter.state = 4
	elseif DailyBeanCounter.state == 4 then
		DailyBeanCounter.state = 1
	end
end

DailyBeanCounterLDB = LibStub("LibDataBroker-1.1"):NewDataObject(brokertext, {
    type = "data source",
    text = "N/A",
    icon = "Interface\\Icons\\INV_Misc_PocketWatch_02",
   OnClick = function(self, button)
        stateChange()

        --[[if IsShiftKeyDown() then
            if button == "LeftButton" then
            elseif button == "RightButton" then
            end
        else
            if button == "RightButton" then
			end
        end]]
    end,
    OnEnter = function(self)
  		local h,m,s = ConvertSeconds(GetQuestResetTime())
        GameTooltip:SetOwner(self, "ANCHOR_NONE")
        GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
        GameTooltip:ClearLines()
        GameTooltip:AddLine("Daily Bean Counter: Show daily quest completion\ncount and time to daily reset in a LDB display",0,1,0)
		GameTooltip:AddLine("-----------------------------------",1,1,0)
		GameTooltip:AddLine("State 1: "..format("%s/%s done", GetDailyQuestsCompleted(),GetMaxDailyQuests()),1,1,0)
		GameTooltip:AddLine("State 2: "..format("%sh %sm to new day",h,m),1,1,0)
		GameTooltip:AddLine("State 3: "..format("%s/%s done - %sh %sm to new day", GetDailyQuestsCompleted(),GetMaxDailyQuests(),h,m),1,1,0)
		GameTooltip:AddLine("State 4: "..format("%s/%s - %sh %sm", GetDailyQuestsCompleted(),GetMaxDailyQuests(),h,m),1,1,0)
 		GameTooltip:AddLine("-----------------------------------",1,1,0)
 		GameTooltip:AddLine("Hint: Click to toggle through display states",1,1,0)
      	GameTooltip:Show()
    end,
    OnLeave = function()
        GameTooltip:Hide()
    end,
})

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", function(self, elap)
    elapsed = elapsed + elap
    if elapsed <= updateperiod then return end
    local h,m,s = ConvertSeconds(GetQuestResetTime())
    --local p1,p2,p3 = "","",""
    if DailyBeanCounter.state == 1 then
 	   output = format("%s/%s done", GetDailyQuestsCompleted(),GetMaxDailyQuests())
    elseif DailyBeanCounter.state == 2 then
 	   output = format("%sh %sm to new day",h,m)
    elseif DailyBeanCounter.state == 3 then
 	   output = format("%s/%s done - %sh %sm to new day", GetDailyQuestsCompleted(),GetMaxDailyQuests(),h,m)
    elseif DailyBeanCounter.state == 4 then
 	   output = format("%s/%s - %sh %sm", GetDailyQuestsCompleted(),GetMaxDailyQuests(),h,m)
    else
 	   output = format("%s/%s done - %sh %sm to new day", GetDailyQuestsCompleted(),GetMaxDailyQuests(),h,m)
 	end
    
    DailyBeanCounterLDB.text = output
    elapsed = 0
end)

--frame:SetScript("OnEvent", function(self,event,...)   end)

